diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 20241c95e..87b3af8b0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -417,24 +417,24 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_DRIFT.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_NETHER.asItem()).setFullBright());
 
-        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_BLUE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_ORANGE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_PINK, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_SILVER, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_BLUE));
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_ORANGE));
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_PINK));
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_SILVER));
 
-        addDispatch(new ItemModelStandard(Items.STATUE_STONE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_BASALT, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_LIMESTONE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_GRANITE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_MARBLE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_PIGMAN, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_STONE));
+        addDispatch(new ItemModelStandard(Items.STATUE_BASALT));
+        addDispatch(new ItemModelStandard(Items.STATUE_LIMESTONE));
+        addDispatch(new ItemModelStandard(Items.STATUE_GRANITE));
+        addDispatch(new ItemModelStandard(Items.STATUE_MARBLE));
+        addDispatch(new ItemModelStandard(Items.STATUE_PIGMAN));
 
         addDispatch(new ItemModelSignPainted(Items.SIGN_PAINTED));
 
-        addDispatch(new ItemModelStandard(Items.FOOD_VENISON_RAW, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.FOOD_VENISON_COOKED, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.FOOD_VENISON_RAW));
+        addDispatch(new ItemModelStandard(Items.FOOD_VENISON_COOKED));
 
-        addDispatch(new ItemModelStandard(Items.RUBYGLASS, "minecraft").setFullBright());
+        addDispatch(new ItemModelStandard(Items.RUBYGLASS).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.RUBYGLASS_COLUMN.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.BLOCK_RUBYGLASS.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.RUBYGLASS_GROWTH.asItem()).setFullBright());
@@ -443,23 +443,23 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.BOULDER_MAGMATIC.asItem()));
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.BOULDER_SULFURIC.asItem()));
 
-        addDispatch(new ItemModelStandard(Items.DOUGH, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.DOUGH));
 
-        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_LEATHER, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_CHAINMAIL, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_IRON, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_DIAMOND, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_GOLD, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_STEEL, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_LEATHER));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_CHAINMAIL));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_IRON));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_DIAMOND));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_GOLD));
+        addDispatch(new ItemModelStandard(Items.ARMOR_WOLF_STEEL));
 
-        addDispatch(new ItemModelStandard(Items.AMMO_ARROW_FLAMING, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.AMMO_ARROW_FLAMING));
 
-        addDispatch(new ItemModelStandard(Items.SULFUR, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.SULFUR));
 
-        addDispatch(new ItemModelStandard(Items.STATUE_GLOOMSTONE, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_NETHERRACK, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_PERMAFROST, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.STATUE_SLATE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.STATUE_GLOOMSTONE));
+        addDispatch(new ItemModelStandard(Items.STATUE_NETHERRACK));
+        addDispatch(new ItemModelStandard(Items.STATUE_PERMAFROST));
+        addDispatch(new ItemModelStandard(Items.STATUE_SLATE));
 
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
index a40772c34..724eed3cc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
@@ -18,7 +18,7 @@ public class ItemModelDoorPainted extends ItemModelStandard {
     public ItemModelDoorPainted(Item item) {
         super(item, null);
     }
-    public @NotNull IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(Entity entity, @NotNull ItemStack itemStack){
         int meta = itemStack.getMetadata();
         return doorIcons[meta & DyeColor.MASK_COLOR];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
index 575a2c636..d1e0a4854 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDye.java
@@ -20,7 +20,7 @@ public class ItemModelDye extends ItemModelStandard {
         super(item, null);
     }
 
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack){
         int meta = itemStack.getMetadata();
         return dyeIcons[meta & DyeColor.MASK_COLOR];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
index 40441a96e..053d68151 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelFishingRod.java
@@ -11,12 +11,12 @@ import org.jetbrains.annotations.Nullable;
 
 public class ItemModelFishingRod extends ItemModelStandard {
     protected IconCoordinate rodCast = TextureRegistry.getTexture("minecraft:item/tool_fishingrod_cast");
-    public ItemModelFishingRod(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelFishingRod(@NotNull Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack){
         if (entity instanceof Player){
             // Use the cast fishing rod texture when holding a cast rod
             if(itemStack == ((Player) entity).getHeldItem() && ((Player) entity).bobberEntity != null)
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
index 28b2fdb10..404bda4cf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelLabel.java
@@ -10,12 +10,12 @@ import org.jetbrains.annotations.Nullable;
 
 public class ItemModelLabel extends ItemModelStandard {
     protected IconCoordinate writtenLabel = TextureRegistry.getTexture("minecraft:item/label_written");
-    public ItemModelLabel(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelLabel(@NotNull Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack)
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack)
     {
         if(itemStack.hasCustomName()) {
             return writtenLabel;
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index 88dc401bf..b69ecdb1f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -27,8 +27,8 @@ public class ItemModelMap extends ItemModelStandard {
     private final Minecraft mc = Minecraft.getMinecraft();
     private final MapItemRenderer renderMapInstance = new MapItemRenderer();
 
-    public ItemModelMap(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelMap(Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
     @Override
@@ -123,7 +123,7 @@ public class ItemModelMap extends ItemModelStandard {
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack) {
         if (!ItemMap.hasInitialized(itemStack)) {
             return TextureRegistry.getTexture("minecraft:item/map_blank");
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
index f68209e11..34280eb21 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
@@ -26,7 +26,7 @@ public class ItemModelNone extends ItemModel{
     }
 
     @Override
-    public IconCoordinate getIcon(@Nullable final Entity entity, final ItemStack itemStack) {
+    public IconCoordinate getIcon(@Nullable final Entity entity, final @NotNull ItemStack itemStack) {
         return null;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java
index accefcc40..802f9b16c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java
@@ -19,12 +19,12 @@ public class ItemModelPaintbrush extends ItemModelStandard {
         }
     }
 
-    public ItemModelPaintbrush(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelPaintbrush(@NotNull Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack) {
         final DyeColor color = ItemPaintBrush.getColor(itemStack);
         if (color == null) {
             return emptyIcon;
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
index fcc90a9e6..585c8a2fa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelQuiver.java
@@ -10,12 +10,12 @@ import org.jetbrains.annotations.Nullable;
 
 public class ItemModelQuiver extends ItemModelStandard {
     protected IconCoordinate quiverFull = TextureRegistry.getTexture("minecraft:item/armor_quiver_empty");
-    public ItemModelQuiver(Item item, String namespace) {
-        super(item, namespace);
+    public ItemModelQuiver(@NotNull Item item, boolean defaultTextureLookup) {
+        super(item, defaultTextureLookup);
     }
 
     @Override
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack)
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, @NotNull ItemStack itemStack)
     {
         if(itemStack.getMetadata() >= itemStack.getItem().getMaxDamage())
             return quiverFull;
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelSignPainted.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelSignPainted.java
index c7eb9ee08..f8556aa1c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelSignPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelSignPainted.java
@@ -18,7 +18,7 @@ public class ItemModelSignPainted extends ItemModelStandard {
     public ItemModelSignPainted(Item item) {
         super(item, null);
     }
-    public @NotNull IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(Entity entity, @NotNull ItemStack itemStack){
         int meta = itemStack.getMetadata();
         return sign[meta & DyeColor.MASK_COLOR];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 7789cc5ab..8ed16bce8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -13,6 +13,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -42,7 +43,20 @@ public class ItemModelStandard extends ItemModel{
 
     protected boolean itemfullBright = false;
 
-    public ItemModelStandard(final Item item, final String namespace) {
+    public ItemModelStandard(final @NotNull Item item) {
+        this(item, true);
+    }
+
+    // Legacy constructor
+    @Deprecated
+    public ItemModelStandard(final @NotNull Item item, final @Nullable String namespace) {
+        this(item, false);
+        if (namespace != null){
+            this.icon = TextureRegistry.getTexture(namespace + ":item/" + item.getKey().substring("item.".length()).replace(".", "_"));
+        }
+    }
+
+    public ItemModelStandard(final @NotNull Item item, final boolean defaultTextureLookup) {
         super(item);
         this.displayPosMap.put(DisplayPos.GROUND, DEFAULT_ITEM_GROUND);
         this.displayPosMap.put(DisplayPos.HEAD, DEFAULT_ITEM_HEAD);
@@ -51,8 +65,8 @@ public class ItemModelStandard extends ItemModel{
         this.displayPosMap.put(DisplayPos.FIRST_PERSON_RIGHT_HAND, DEFAULT_ITEM_FIRST_PERSON_RIGHT_HAND);
         this.displayPosMap.put(DisplayPos.FIRST_PERSON_LEFT_HAND, DEFAULT_ITEM_FIRST_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
         this.displayPosMap.put(DisplayPos.FIXED, DEFAULT_ITEM_FIXED);
-        if (namespace != null){
-            this.icon = TextureRegistry.getTexture(namespace + ":item/" + item.getKey().substring("item.".length()).replace(".", "_"));
+        if (defaultTextureLookup){
+            this.icon = TextureRegistry.getTexture(item.namespaceID);
         }
     }
 
@@ -250,7 +264,7 @@ public class ItemModelStandard extends ItemModel{
         tessellator.addVertex(x + width,y,          z);
     }
 
-    public @NotNull IconCoordinate getIcon(@Nullable final Entity entity, final ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(@Nullable final Entity entity, final @NotNull ItemStack itemStack){
         return this.icon;
     }
     public int getColor(final ItemStack stack)
@@ -262,9 +276,19 @@ public class ItemModelStandard extends ItemModel{
         return 0xffffffff;
     }
 
-    public ItemModelStandard setFullBright()
+    public @NotNull ItemModelStandard setFullBright()
     {
         this.itemfullBright = true;
         return this;
     }
+
+    public @NotNull ItemModelStandard setIcon(@NotNull NamespaceID textureId) {
+        this.icon = TextureRegistry.getTexture(textureId);
+        return this;
+    }
+
+    public @NotNull ItemModelStandard setIcon(@NotNull String textureId) {
+        this.icon = TextureRegistry.getTexture(textureId);
+        return this;
+    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index 0cbf0a55f..a71958762 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -128,6 +128,9 @@ public class GLRenderer {
     private final float[] alphaTestStack = new float[RENDER_FRAMES_STACK_SIZE];
     private float currentAlphaTest = 0.1f;
 
+    private final float[] lightMapStrengthStack = new float[RENDER_FRAMES_STACK_SIZE];
+    private float currentLightMapStrength = 1f;
+
     private int stackIndex = 0;
 
 
@@ -158,6 +161,7 @@ public class GLRenderer {
         shader.uniformMat4f("model", modelM4f());
         shader.uniformMat4f("texture", textureM4f());
 
+        shader.uniformFloat("uLightMapStrength", instance.currentLightMapStrength);
         shader.uniformFloat("uAlphaTest", instance.currentAlphaTest);
         shader.uniformVec4f("uColor", Color.redFromInt(instance.currentColor)/255f, Color.greenFromInt(instance.currentColor)/255f, Color.blueFromInt(instance.currentColor)/255f, Color.alphaFromInt(instance.currentColor)/255f);
         shader.uniformFloat("uCurrentTick", instance.mc.ticksRan + instance.mc.timer.partialTicks);
@@ -355,6 +359,14 @@ public class GLRenderer {
         return instance.currentAlphaTest;
     }
 
+    public static void setLightMapStrength(float lightMapStrength) {
+        instance.currentLightMapStrength = lightMapStrength;
+    }
+
+    public static float getLightMapStrength() {
+        return instance.currentLightMapStrength;
+    }
+
     public static void setColor1i(int argb) {
         instance.currentColor = argb;
     }
@@ -427,6 +439,7 @@ public class GLRenderer {
         instance.polygonUnitsStack[instance.stackIndex] = instance.currentPolygonUnits;
         instance.lightIndexStack[instance.stackIndex] = instance.currentLightIndex;
         instance.alphaTestStack[instance.stackIndex] = instance.currentAlphaTest;
+        instance.lightMapStrengthStack[instance.stackIndex] = instance.currentLightMapStrength;
 
         if (DEBUG) {
             StackTraceElement[] eles = Thread.currentThread().getStackTrace();
@@ -527,6 +540,7 @@ public class GLRenderer {
 
         instance.currentLightIndex = instance.lightIndexStack[instance.stackIndex];
         instance.currentAlphaTest = instance.alphaTestStack[instance.stackIndex];
+        instance.currentLightMapStrength = instance.lightMapStrengthStack[instance.stackIndex];
     }
 
     protected static void reset() {
diff --git a/game/client/src/main/resources/shaders/color_world.fsh b/game/client/src/main/resources/shaders/color_world.fsh
index dfd85c2ff..d67aea9e1 100644
--- a/game/client/src/main/resources/shaders/color_world.fsh
+++ b/game/client/src/main/resources/shaders/color_world.fsh
@@ -6,6 +6,7 @@ in vec4 Color;
 in vec2 LightMapCoord;
 in vec3 Light;
 
+uniform float uLightMapStrength;
 uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
@@ -65,7 +66,7 @@ vec4 computeFog(vec4 color) {
 }
 
 void main() {
-    vec4 lightColor = texture(lighttex, LightMapCoord);
+    vec4 lightColor = mix(vec4(1, 1, 1, 1), texture(lighttex, LightMapCoord), uLightMapStrength);
 
     vec4 oColor = lightColor * Color * uColor;
     vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
diff --git a/game/client/src/main/resources/shaders/entity.fsh b/game/client/src/main/resources/shaders/entity.fsh
index 380af1944..fdaca5df0 100644
--- a/game/client/src/main/resources/shaders/entity.fsh
+++ b/game/client/src/main/resources/shaders/entity.fsh
@@ -5,6 +5,7 @@ out vec4 FragColor;
 in vec2 TexCoord;
 in vec3 Light;
 
+uniform float uLightMapStrength;
 uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uLightmap;
@@ -66,7 +67,7 @@ vec4 computeFog(vec4 color) {
 }
 
 void main() {
-    vec4 lightColor = texture(lighttex, uLightmap);
+    vec4 lightColor = mix(vec4(1, 1, 1, 1), texture(lighttex, uLightmap), uLightMapStrength);
     vec4 texColor = texture(colortex, TexCoord);
 
     vec4 oColor = texColor * lightColor * uColor;
diff --git a/game/client/src/main/resources/shaders/font.fsh b/game/client/src/main/resources/shaders/font.fsh
index 769eaa3dd..d86522da3 100644
--- a/game/client/src/main/resources/shaders/font.fsh
+++ b/game/client/src/main/resources/shaders/font.fsh
@@ -22,6 +22,7 @@ in vec2 Size;
 in float Config;
 
 uniform float uAlphaTest;
+uniform float uLightMapStrength;
 uniform vec4 uColor;
 
 uniform sampler2D colortex;
@@ -51,9 +52,8 @@ vec4 bold(vec2 coord, vec4 text, vec4 textColor)
 	return text;
 }
 
-vec4 colorAtPoint(vec2 point) {
+vec4 colorAtPoint(vec2 point, vec4 tint) {
     uint config = uint(Config + 0.01);
-    vec4 tint = texture(lighttex, Lightmap) * uColor;
 
     vec4 color = vec4(0);
     if (sampleInside(point)) {
@@ -74,17 +74,17 @@ vec4 colorAtPoint(vec2 point) {
     return color;
 }
 
-bool canReplace(vec2 tex) {
-    vec4 c = colorAtPoint(tex);
+bool canReplace(vec2 tex, vec4 tint) {
+    vec4 c = colorAtPoint(tex, tint);
     return c.a > 0.1;
 }
 
-float outline()
+float outline(vec4 tint)
 {
 	for(int x = -sh.x; x <= sh.x; x++)
 	for(int y = -sh.y; y <= sh.y; y++)
 	{
-		if(canReplace(TexCoord + vec2(x,y)/rh)) return 1.0f;
+		if(canReplace(TexCoord + vec2(x,y)/rh, tint)) return 1.0f;
 	}
 
 	return 0.0f;
@@ -92,15 +92,15 @@ float outline()
 
 void main() {
     uint config = uint(Config + 0.01);
-    vec4 tint = texture(lighttex, Lightmap) * uColor;
-    FragColor = colorAtPoint(TexCoord);
+    vec4 tint = mix(vec4(1, 1, 1, 1), texture(lighttex, Lightmap), uLightMapStrength) * uColor;
+    FragColor = colorAtPoint(TexCoord, tint);
 	
     if (FragColor.a < 0.1) {
         if ((config & MASK_OUTLINE) != 0) {
-			FragColor = vec4(Color.rgb/4, Color.a) * tint * outline();
+			FragColor = vec4(Color.rgb/4, Color.a) * tint * outline(tint);
         } else if ((config & MASK_SHADOW) != 0) {
             vec2 upLeft = TexCoord - vec2(1, 1)/F_PIX;
-            if (canReplace(upLeft)) {
+            if (canReplace(upLeft, tint)) {
                 FragColor = vec4(Color.rgb/4, Color.a) * tint;
             }
         }
diff --git a/game/client/src/main/resources/shaders/item.fsh b/game/client/src/main/resources/shaders/item.fsh
index a4e565f79..af27bde3e 100644
--- a/game/client/src/main/resources/shaders/item.fsh
+++ b/game/client/src/main/resources/shaders/item.fsh
@@ -8,6 +8,7 @@ in vec2 LightMapCoord;
 in vec3 Light;
 in vec3 Norm;
 
+uniform float uLightMapStrength;
 uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
@@ -71,7 +72,7 @@ vec4 computeFog(vec4 color) {
 
 void main() {
     vec2 emissiveBrightness = texture(emissivetex, TexCoord).xy;
-    vec4 lightColor = texture(lighttex, vec2(max(LightMapCoord.x, emissiveBrightness.x), max(LightMapCoord.y, emissiveBrightness.y)));
+    vec4 lightColor = mix(vec4(1, 1, 1, 1), texture(lighttex, vec2(max(LightMapCoord.x, emissiveBrightness.x), max(LightMapCoord.y, emissiveBrightness.y))), uLightMapStrength);
     vec4 texColor = texture(colortex, TexCoord);
     vec4 maskColor = texture(colormasktex, TexCoord);
 
diff --git a/game/client/src/main/resources/shaders/particle.fsh b/game/client/src/main/resources/shaders/particle.fsh
index e29b9cbeb..2eb502b1b 100644
--- a/game/client/src/main/resources/shaders/particle.fsh
+++ b/game/client/src/main/resources/shaders/particle.fsh
@@ -5,6 +5,7 @@ in vec4 Color;
 in vec2 TexCoord;
 in vec2 LightMapCoord;
 
+uniform float uLightMapStrength;
 uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
@@ -68,7 +69,7 @@ vec4 computeFog(vec4 color) {
 
 void main() {
     vec2 emissiveBrightness = texture(emissivetex, TexCoord).xy;
-    vec4 lightColor = texture(lighttex, vec2(max(LightMapCoord.x, emissiveBrightness.x), max(LightMapCoord.y, emissiveBrightness.y)));
+    vec4 lightColor = mix(vec4(1, 1, 1, 1), texture(lighttex, vec2(max(LightMapCoord.x, emissiveBrightness.x), max(LightMapCoord.y, emissiveBrightness.y))), uLightMapStrength);
     vec4 texColor = texture(colortex, TexCoord);
     vec4 maskColor = texture(colormasktex, TexCoord);
 
diff --git a/game/client/src/main/resources/shaders/terrain.fsh b/game/client/src/main/resources/shaders/terrain.fsh
index ce9aaa24d..bad168a16 100644
--- a/game/client/src/main/resources/shaders/terrain.fsh
+++ b/game/client/src/main/resources/shaders/terrain.fsh
@@ -9,6 +9,7 @@ in vec2 LightMapCoord;
 in vec3 Light;
 in vec4 Norm;
 
+uniform float uLightMapStrength;
 uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
@@ -72,7 +73,7 @@ vec4 computeFog(vec4 color) {
 
 void main() {
     vec2 emissiveBrightness = texture(emissivetex, TexCoord).xy;
-    vec4 lightColor = texture(lighttex, vec2(max(LightMapCoord.x, emissiveBrightness.x), max(LightMapCoord.y, emissiveBrightness.y)));
+    vec4 lightColor = mix(vec4(1, 1, 1, 1), texture(lighttex, vec2(max(LightMapCoord.x, emissiveBrightness.x), max(LightMapCoord.y, emissiveBrightness.y))), uLightMapStrength);
     vec4 texColor = texture(colortex, TexCoord);
     vec4 maskColor = texture(colormasktex, TexCoord);
 
diff --git a/game/client/src/main/resources/shaders/world.fsh b/game/client/src/main/resources/shaders/world.fsh
index 990459bfb..0e7431719 100644
--- a/game/client/src/main/resources/shaders/world.fsh
+++ b/game/client/src/main/resources/shaders/world.fsh
@@ -7,6 +7,7 @@ in vec2 TexCoord;
 in vec2 LightMapCoord;
 in vec3 Light;
 
+uniform float uLightMapStrength;
 uniform float uAlphaTest;
 uniform vec4 uColor;
 uniform vec2 uViewPortSize;
@@ -67,7 +68,7 @@ vec4 computeFog(vec4 color) {
 }
 
 void main() {
-    vec4 lightColor = texture(lighttex, LightMapCoord);
+    vec4 lightColor = mix(vec4(1, 1, 1, 1), texture(lighttex, LightMapCoord), uLightMapStrength);
     vec4 texColor = texture(colortex, TexCoord);
 
     vec4 oColor = texColor * lightColor * Color * uColor;
diff --git a/game/core/src/main/java/net/minecraft/core/Global.java b/game/core/src/main/java/net/minecraft/core/Global.java
index e52cbd558..fe2859e01 100644
--- a/game/core/src/main/java/net/minecraft/core/Global.java
+++ b/game/core/src/main/java/net/minecraft/core/Global.java
@@ -8,7 +8,7 @@ public class Global
 	public static final int DAY_LENGTH_TICKS = 24000;
 	public static final @NotNull String VERSION = Version.BUILD_CHANNEL.modifyVersionString(Version.VERSION);
 	public static final @NotNull BuildChannel BUILD_CHANNEL = Version.BUILD_CHANNEL;
-	public static final int CURRENT_SAVE_VERSION = 19135;
+	public static final int CURRENT_SAVE_VERSION = 19136;
 	public static final int CURRENT_CHUNK_VERSION = 3;
 	public static boolean isServer = false;
 	public static final boolean DISABLE_OLD_WORLDS = false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index af0cb7f8e..507972aca 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -62,7 +62,6 @@ public final class Block<T extends BlockLogic>
     public float friction;
     public int emission;
     public @Nullable Integer lightBlock = null;
-    public boolean immovable = false;
     public boolean isEntityTile = false;
     public boolean disabledNeighborMetaNotify = false;
     public boolean shouldTick = false;
@@ -82,7 +81,6 @@ public final class Block<T extends BlockLogic>
         this.enableStats = true;
         this.blockParticleGravity = 1.0F;
         this.friction = 0.6F;
-        this.immovable = false;
     }
 
     private int setupNumericId(final int id) {
@@ -150,11 +148,6 @@ public final class Block<T extends BlockLogic>
         return this;
     }
 
-    public Block<T> withImmovableFlagSet() {
-        this.immovable = true;
-        return this;
-    }
-
     public Block<T> withBlastResistance(final float blastResistance) {
         this.blastResistance = blastResistance * 3F;
         return this;
@@ -451,11 +444,6 @@ public final class Block<T extends BlockLogic>
         return this.logic.getStrength(world, tilePos, side, player);
     }
 
-    @Override
-    public boolean getImmovable() {
-        return this.logic.getImmovable();
-    }
-
     @Override
     public float getBlastResistance(final @Nullable Entity entity) {
         return this.logic.getBlastResistance(entity);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
index cb1924579..d161131d3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockInterface.java
@@ -209,8 +209,6 @@ interface BlockInterface {
         return this.getStrength(world, new TilePos(x, y, z), side, player);
     }
 
-    boolean getImmovable();
-
     float getBlastResistance(final @Nullable Entity entity);
 
     @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final boolean useSelectionAABB);
